Index: /trunk/Document/input/building/bcc.md
===================================================================
--- /trunk/Document/input/building/bcc.md	(revision 355)
+++ /trunk/Document/input/building/bcc.md	(revision 355)
@@ -0,0 +1,64 @@
+\noindex
+\language ^en$
+
+# Using Borland C++ 5.5 {Build}
+
+This page explains how to build using Borland C++ 5.5.
+
+## Steps
+
+### 1. Requirements
+ - Borland C++ 5.5
+ - Cygwin (at least checked working on 2007)
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Setup the build environment
+
+Enter `C:\Cygwin` (probably depends on the platform), and run `cygwin.bat`.
+
+Then, set `BORLAND` to the prefix of Borland C++. (e.g. `C:\BC55`)
+
+### 5. Build
+
+Run `./make-installer.sh bcc`, and you should get these files:
+ - install.exe (Setup program)
+ - tewi.7z (Archive)
+
+\language ^jp$
+
+# Borland C++ 5.5を使う {ビルド}
+
+ここではBorland C++ 5.5を使用してコンパイルする方法を紹介します。
+
+## ステップ
+
+### 1. 必要なもの
+ - Borland C++ 5.5
+ - Cygwin (2007では動作確認しました)
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. ビルド環境を作る
+
+`C:\Cygwin` (環境によって変化すると思われます)に入り、`cygwin.bat`を実行してください。
+
+そしたら`BORLAND`という環境変数をBorland C++ 5.5のインストールディレクトリへのパスにしてください。(例: `C:\BC55`)
+
+### 5. ビルドする
+
+`./make-installer.sh bcc`を実行してください。そしたら以下のものが作成されるはずです:
+ - install.exe (セットアッププログラム)
+ - tewi.7z (アーカイブ)
Index: /trunk/Document/input/building/cygwin.md
===================================================================
--- /trunk/Document/input/building/cygwin.md	(revision 355)
+++ /trunk/Document/input/building/cygwin.md	(revision 355)
@@ -0,0 +1,58 @@
+\noindex
+\language ^en$
+
+# Using Cygwin {Build}
+
+This page explains how to build using Cygwin.
+
+## Steps
+
+### 1. Requirements
+ - Cygwin (at least checked working on 2007)
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Setup the build environment
+
+Enter `C:\Cygwin` (probably depends on the platform), and run `cygwin.bat`.
+
+### 5. Build
+
+Run `./make-installer.sh cygwin`, and you should get these files:
+ - install.exe (Setup program)
+ - tewi.7z (Archive)
+
+\language ^jp$
+
+# Cygwinを使う {ビルド}
+
+ここではCygwinを使用してコンパイルする方法を紹介します。
+
+## ステップ
+
+### 1. 必要なもの
+ - Cygwin (2007では動作確認しました)
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. ビルド環境を作る
+
+`C:\Cygwin` (環境によって変化すると思われます)に入り、`cygwin.bat`を実行してください。
+
+### 5. ビルドする
+
+`./make-installer.sh cygwin`を実行してください。そしたら以下のものが作成されるはずです:
+ - install.exe (セットアッププログラム)
+ - tewi.7z (アーカイブ)
Index: /trunk/Document/input/building/mingw.md
===================================================================
--- /trunk/Document/input/building/mingw.md	(revision 355)
+++ /trunk/Document/input/building/mingw.md	(revision 355)
@@ -0,0 +1,52 @@
+\noindex
+\language ^en$
+
+# Using MinGW-w64 {Build}
+
+This page explains how to build using MinGW-w64.
+
+## Steps
+
+### 1. Requirements
+ - MinGW-w64
+ - Linux or NetBSD environment
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Build
+
+Run `./make-installer.sh win32` or `./make-installer.sh win64`, and you should get these files:
+ - install.exe (Setup program)
+ - tewi.7z (Archive)
+
+\language ^jp$
+
+# MinGW-w64を使う {ビルド}
+
+ここではMinGW-w64を使用してコンパイルする方法を紹介します。
+
+## ステップ
+
+### 1. 必要なもの
+ - MinGW-w64
+ - Linux環境かNetBSD環境
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. ビルドする
+
+`./make-installer.sh win32`か`./make-installer.sh win64`を実行してください。そしたら以下のものが作成されるはずです:
+ - install.exe (セットアッププログラム)
+ - tewi.7z (アーカイブ)
Index: /trunk/Document/input/building/nextstep.md
===================================================================
--- /trunk/Document/input/building/nextstep.md	(revision 355)
+++ /trunk/Document/input/building/nextstep.md	(revision 355)
@@ -0,0 +1,57 @@
+\language ^en$
+# Build for NeXTSTEP {Build}
+
+Tewi HTTPd has the NeXTSTEP support, which is checked working on NeXTSTEP 3.3.
+
+## Steps
+
+### 1. Install packages
+
+It should work on 3.3 if below stuffs are installed:
+ - Developer kit
+ - GNU make
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=nextstep PREFIX=prefix`. PREFIX is set to `/usr/local` by default.
+
+### 5. Install
+
+Run `make PLATFORM=nextstep PREFIX=prefix install` as **root user**.
+
+\language ^jp$
+# NeXTSTEP向けにビルドする {ビルド}
+
+Tewi HTTPdにはNeXTSTEP 3.3で動作確認がされているNeXTSTEPサポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+3.3の場合、以下のものがあれば動くはずです:
+ - Developer kit
+ - GNU make
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=nextstep PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`/usr/local`になります。
+
+### 5. インストールする
+
+`make PLATFORM=nextstep PREFIX=おすきなプレフィックス install`を**root**ユーザーで実行してください。
Index: /trunk/Document/input/building/vc6.md
===================================================================
--- /trunk/Document/input/building/vc6.md	(revision 355)
+++ /trunk/Document/input/building/vc6.md	(revision 355)
@@ -0,0 +1,60 @@
+\noindex
+\language ^en$
+
+# Using Visual C++ 6.0 {Build}
+
+This page explains how to build using Visual C++ 6.0.
+
+## Steps
+
+### 1. Requirements
+ - Visual C++ 6.0
+ - Cygwin (at least checked working on 2007)
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Setup the build environment
+
+Run `vcvars32` to set environment variables, and enter `C:\Cygwin` (probably depends on the platform), and run `cygwin.bat`.
+
+### 5. Build
+
+Run `./make-installer.sh vc6`, and you should get these files:
+ - install.exe (Setup program)
+ - tewi.7z (Archive)
+
+\language ^jp$
+
+# Visual C++ 6.0を使う {ビルド}
+
+ここではVisual C++ 6.0を使用してコンパイルする方法を紹介します。
+
+## ステップ
+
+### 1. 必要なもの
+ - Visual C++ 6.0
+ - Cygwin (2007では動作確認しました)
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. ビルド環境を作る
+
+`vcvars32`を実行して環境変数を設定し、`C:\Cygwin` (環境によって変化すると思われます)に入り、`cygwin.bat`を実行してください。
+
+### 5. ビルドする
+
+`./make-installer.sh vc6`を実行してください。そしたら以下のものが作成されるはずです:
+ - install.exe (セットアッププログラム)
+ - tewi.7z (アーカイブ)
Index: /trunk/Document/input/building/watcom.md
===================================================================
--- /trunk/Document/input/building/watcom.md	(revision 355)
+++ /trunk/Document/input/building/watcom.md	(revision 355)
@@ -0,0 +1,52 @@
+\noindex
+\language ^en$
+
+# Using Open Watcom 2.0 {Build}
+
+This page explains how to build using Open Watcom 2.0.
+
+## Steps
+
+### 1. Requirements
+ - Open Watcom 2.0
+ - Linux or NetBSD environment
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Build
+
+Run `./make-installer.sh watcom`, and you should get these files:
+ - install.exe (Setup program)
+ - tewi.7z (Archive)
+
+\language ^jp$
+
+# Open Watcom 2.0を使う {ビルド}
+
+ここではOpen Watcom 2.0を使用してコンパイルする方法を紹介します。
+
+## ステップ
+
+### 1. 必要なもの
+ - Open Watcom 2.0
+ - Linux環境かNetBSD環境
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. ビルドする
+
+`./make-installer.sh watcom`を実行してください。そしたら以下のものが作成されるはずです:
+ - install.exe (セットアッププログラム)
+ - tewi.7z (アーカイブ)
Index: /trunk/Document/input/building/windows.md
===================================================================
--- /trunk/Document/input/building/windows.md	(revision 355)
+++ /trunk/Document/input/building/windows.md	(revision 355)
@@ -0,0 +1,29 @@
+\language ^en$
+# Build for Windows {Build}
+
+Tewi HTTPd has the Windows support, which is checked working on Windows 2000 and 98 (usually).
+
+## Steps
+
+### 1. Choose compiler
+All of them have common dependency: NSIS.
+ - [Visual C++ 6.0](vc6.html)
+ - [Open Watcom 2.0](watcom.html)
+ - [Borland C++ 5.5](bcc.html)
+ - [MinGW-w64](mingw.html)
+ - [Cygwin](cygwin.html) (Not really recommended)
+
+\language ^jp$
+# Windows向けにビルドする {ビルド}
+
+Tewi HTTPdにはWindows 2000/98で(だいたい)動作確認がされているWindowsサポートがあります。
+
+## ステップ
+
+### 1. コンパイラを決める
+これら全ておいてNSISが必要です。
+ - [Visual C++ 6.0](vc6.html)
+ - [Open Watcom 2.0](watcom.html)
+ - [Borland C++ 5.5](bcc.html)
+ - [MinGW-w64](mingw.html)
+ - [Cygwin](cygwin.html) (あまりおすすめではないです)
Index: /trunk/make-installer.sh
===================================================================
--- /trunk/make-installer.sh	(revision 354)
+++ /trunk/make-installer.sh	(revision 355)
@@ -14,5 +14,10 @@
 }
 
+rm -rf Tewi
+rm -f tewi.exe
+rm -f itworks.html
+rm -f generated.conf
 rm -f install.exe
+rm -f tewi.7z
 
 VERSION=`make get-version`