Index: trunk/Document/input/building/haiku.md
===================================================================
--- trunk/Document/input/building/haiku.md	(revision 357)
+++ trunk/Document/input/building/haiku.md	(revision 357)
@@ -0,0 +1,53 @@
+\language ^en$
+# Build for Haiku {Build}
+
+Tewi HTTPd has the Haiku support.
+
+## Steps
+
+### 1. Install packages
+
+There are no required packages, they should be installed by default.
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=haiku PREFIX=prefix`. PREFIX is set to `/usr/local` by default.
+
+### 5. Install
+
+Run `make PLATFORM=haiku PREFIX=prefix install` as **root user**.
+
+\language ^jp$
+# Haiku向けにビルドする {ビルド}
+
+Tewi HTTPdにはHaikuサポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+追加で必要なパッケージはありません。デフォルトでインストールされているはずです。
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=haiku PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`/usr/local`になります。
+
+### 5. インストールする
+
+`make PLATFORM=haiku PREFIX=おすきなプレフィックス install`を**root**ユーザーで実行してください。
Index: trunk/Document/input/building/netbsd.md
===================================================================
--- trunk/Document/input/building/netbsd.md	(revision 357)
+++ trunk/Document/input/building/netbsd.md	(revision 357)
@@ -0,0 +1,53 @@
+\language ^en$
+# Build for NetBSD {Build}
+
+Tewi HTTPd has the NetBSD support, which is checked working on amd64 10.0.
+
+## Steps
+
+### 1. Install packages
+
+There are no required packages, they should be installed by default.
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=netbsd PREFIX=prefix`. PREFIX is set to `/usr/local` by default.
+
+### 5. Install
+
+Run `make PLATFORM=netbsd PREFIX=prefix install` as **root user**.
+
+\language ^jp$
+# NetBSD向けにビルドする {ビルド}
+
+Tewi HTTPdにはamd64 10.0で動作確認がされているNetBSDサポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+追加で必要なパッケージはありません。デフォルトでインストールされているはずです。
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=netbsd PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`/usr/local`になります。
+
+### 5. インストールする
+
+`make PLATFORM=netbsd PREFIX=おすきなプレフィックス install`を**root**ユーザーで実行してください。
Index: trunk/Document/input/building/openbsd.md
===================================================================
--- trunk/Document/input/building/openbsd.md	(revision 357)
+++ trunk/Document/input/building/openbsd.md	(revision 357)
@@ -0,0 +1,55 @@
+\language ^en$
+# Build for OpenBSD {Build}
+
+Tewi HTTPd has the OpenBSD support.
+
+## Steps
+
+### 1. Install packages
+
+It should work if below packages are installed:
+ - `openssl` (If you want TLS/SSL)
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=openbsd PREFIX=prefix`. PREFIX is set to `/usr/local` by default.
+
+### 5. Install
+
+Run `make PLATFORM=openbsd PREFIX=prefix install` as **root user**.
+
+\language ^jp$
+# OpenBSD向けにビルドする {ビルド}
+
+Tewi HTTPdにはOpenBSDサポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+以下のものがあれば動くはずです:
+ - `openssl` (TLS/SSL機能が必要なら)
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=openbsd PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`/usr/local`になります。
+
+### 5. インストールする
+
+`make PLATFORM=openbsd PREFIX=おすきなプレフィックス install`を**root**ユーザーで実行してください。
Index: trunk/Document/input/building/os2.md
===================================================================
--- trunk/Document/input/building/os2.md	(revision 357)
+++ trunk/Document/input/building/os2.md	(revision 357)
@@ -0,0 +1,49 @@
+\language ^en$
+# Build for OS/2 {Build}
+
+Tewi HTTPd has the OS/2 support.
+
+## Steps
+
+### 1. Install packages
+
+It should be able to compile on Debian if below packages are installed:
+ - `build-essential`
+ - Open Watcom 2.0
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=os2 PREFIX=prefix`. PREFIX is set to `C:/Tewi` by default.
+
+\language ^jp$
+# OS/2向けにビルドする {ビルド}
+
+Tewi HTTPdにはOS/2サポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+Debianの場合、以下のものがあればコンパイルできるはずです:
+ - `build-essential`
+ - Open Watcom 2.0
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=os2 PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`C:/Tewi`になります。
Index: trunk/Document/input/building/ps3.md
===================================================================
--- trunk/Document/input/building/ps3.md	(revision 357)
+++ trunk/Document/input/building/ps3.md	(revision 357)
@@ -0,0 +1,49 @@
+\language ^en$
+# Build for PlayStation 3 {Build}
+
+Tewi HTTPd has the PlayStation 3 support.
+
+## Steps
+
+### 1. Install packages
+
+It should be able to compile on Debian if below packages are installed:
+ - `build-essential`
+ - PS3Dev
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=ps3 PREFIX=prefix`. PREFIX is set to `/dev_hdd0/game/TEWI_00-0/USRDIR` by default.
+
+\language ^jp$
+# PlayStation 3向けにビルドする {ビルド}
+
+Tewi HTTPdにはPlayStation 3サポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+Debianの場合、以下のものがあればコンパイルできるはずです:
+ - `build-essential`
+ - PS3Dev
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=ps3 PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`/dev_hdd0/game/TEWI_00-0/USRDIR`になります。
Index: trunk/Document/input/building/psp.md
===================================================================
--- trunk/Document/input/building/psp.md	(revision 357)
+++ trunk/Document/input/building/psp.md	(revision 357)
@@ -0,0 +1,49 @@
+\language ^en$
+# Build for PlayStation Portable {Build}
+
+Tewi HTTPd has the PlayStation Portable support.
+
+## Steps
+
+### 1. Install packages
+
+It should be able to compile on Debian if below packages are installed:
+ - `build-essential`
+ - PSPDev
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=psp PREFIX=prefix`. PREFIX is set to `ms0:/PSP/GAME/httpd` by default.
+
+\language ^jp$
+# PlayStation Portable向けにビルドする {ビルド}
+
+Tewi HTTPdにはPlayStation Portableサポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+Debianの場合、以下のものがあればコンパイルできるはずです:
+ - `build-essential`
+ - PSPDev
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=psp PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`ms0:/PSP/GAME/httpd`になります。
Index: trunk/Document/input/building/unixware.md
===================================================================
--- trunk/Document/input/building/unixware.md	(revision 357)
+++ trunk/Document/input/building/unixware.md	(revision 357)
@@ -0,0 +1,57 @@
+\language ^en$
+# Build for UnixWare {Build}
+
+Tewi HTTPd has the UnixWare support, which is checked working on 7.1.1.
+
+## Steps
+
+### 1. Install packages
+
+It should work if below packages are installed:
+ - UDK
+ - `make`
+
+### 2. Get the source code
+
+You can get the source codes using several VCS. ([Official Repository List](repos.html))
+
+### 3. Create config.h
+
+Copy config.h.tmpl to config.h. Edit it if needed.
+
+### 4. Run make
+
+Run `make PLATFORM=unixware PREFIX=prefix`. PREFIX is set to `/usr/local` by default.
+
+### 5. Install
+
+Run `make PLATFORM=unixware PREFIX=prefix install` as **root user**.
+
+\language ^jp$
+# UnixWare向けにビルドする {ビルド}
+
+Tewi HTTPdには7.1.1で動作確認がされているUnixWareサポートがあります。
+
+## ステップ
+
+### 1. パッケージを入れる
+
+以下のものがあれば動くはずです:
+ - UDK
+ - `make`
+
+### 2. ソースコードを持って来る
+
+ソースコードは色々なVCSを使って取得することができます。 ([公認リポジトリリスト](repos.html))
+
+### 3. config.hを作成する
+
+config.h.tmplをconfig.hにコピーしてください。必要があれば編集してください。
+
+### 4. makeを実行する
+
+`make PLATFORM=unixware PREFIX=おすきなプレフィックス`を実行してください。PREFIXの指定が無い場合は`/usr/local`になります。
+
+### 5. インストールする
+
+`make PLATFORM=unixware PREFIX=おすきなプレフィックス install`を**root**ユーザーで実行してください。